// Author: Ryan Schmidt  (rms@unknownroad.com)  http://www.unknownroad.com
// Copyright (c) 2009. All Rights Reserved.
// libgeometry is supplied "AS IS". The Author disclaims all warranties, expressed or implied, including,
// without limitation, the warranties of merchantability and of fitness for any purpose. The Author assume no liability
// for direct, indirect, incidental, special, exemplary, or consequential damages, which may result from the use of
// libgeometry, even if advised of the possibility of such damage. Permission is hereby granted to use, copy, 
// modify, and distribute this source code, or portions hereof, for any purpose, without fee, subject to the following restrictions:
// 1) The origin of this source code must not be misrepresented.
// 2) This Copyright notice may not be removed or altered from any source or altered source distribution.
// The Author specifically permits, without fee, the use of this source code as a component in commercial products.
// [LICENSE]
#pragma once
#include "config.h"
#include <VFTriangleMesh.h>
#include <IMeshBVTree.h>
#include <Frame.h>

namespace rms {

class VertexSelection
{
public:
	VertexSelection(void);
	~VertexSelection(void);

	void SetSurface(rms::VFTriangleMesh * pMesh, rms::IMeshBVTree * pBVTree);

	void TryAddVertex( const rms::Frame3f & vFrame, bool bAppendToSelection = false );
	void ClearSelection();
	
	bool IsValid();
	const std::set< IMesh::VertexID > & Vertices() { return m_vVertices; }

	Wml::Vector3f Centroid();

	void Render(  );

	void SaveSelection(const char * pFilename);
	void LoadSelection(const char * pFilename);

protected:
	rms::VFTriangleMesh * m_pMesh;
	rms::IMeshBVTree * m_pBVTree;

	std::set< IMesh::VertexID > m_vVertices;
};


} // end namespace rms