// Author: Ryan Schmidt  (rms@unknownroad.com)  http://www.unknownroad.com
// Copyright (c) 2009. All Rights Reserved.
// libgeometry is supplied "AS IS". The Author disclaims all warranties, expressed or implied, including,
// without limitation, the warranties of merchantability and of fitness for any purpose. The Author assume no liability
// for direct, indirect, incidental, special, exemplary, or consequential damages, which may result from the use of
// libgeometry, even if advised of the possibility of such damage. Permission is hereby granted to use, copy, 
// modify, and distribute this source code, or portions hereof, for any purpose, without fee, subject to the following restrictions:
// 1) The origin of this source code must not be misrepresented.
// 2) This Copyright notice may not be removed or altered from any source or altered source distribution.
// The Author specifically permits, without fee, the use of this source code as a component in commercial products.
// [LICENSE]
#ifndef __RMS_DEBUG_H__
#define __RMS_DEBUG_H__

#ifdef _WIN32
#include "windows.h"
#pragma warning(disable:4505)
#endif

#include <string>
using namespace std;

#include <stdio.h>
#include <stdarg.h>


static int _RMSInfo(const char * str, ...)
{	
	static char buf[1024];
	va_list args;

	va_start(args, str);
	vsprintf_s(buf, 1024, str, args);
#ifdef _WIN32
	OutputDebugString(buf);
#else
	fprintf(stderr, "%s", buf);
#endif
	va_end(args);

	return 0;
}

static string _RMSInfoString(char * str, ...)
{	
	static char buf[1024];
	va_list args;

	va_start(args, str);
	vsprintf_s(buf, 1024, str, args);
	va_end(args);
	return string(buf);
}



#endif   // __RMS_DEBUG_H__